package lab7;

import java.util.LinkedList;
import java.util.List;

public class Queue<E> {

    private final List<E> data;
    private boolean active;

    public Queue() {
        data = new LinkedList();
        active = true;
    }

    public synchronized void push(E element) {
        if (active) {
            data.add(element);
            notify();
        }
    }

    public synchronized E pull()  {
        while (active && data.isEmpty()) {
            try { 
                wait(); 
            } catch (InterruptedException e) {}
        }
        return data.isEmpty()? null : data.removeFirst();
    }
    
    public synchronized void close() {
        active = false;
        notify();
    }
    
}
